import numpy as np
import netCDF4 as nc
import matplotlib.pyplot as plt
from m2003 import m2003

f = nc.Dataset('TS_jas_c8.nc','r')
temp_jas_c8 = f.variables['temp'][:]
salt_jas_c8 = f.variables['salt'][:]
xt = f.variables['xt_ocean'][:]
yt = f.variables['yt_ocean'][:]
f.close()

f = nc.Dataset('TS_jas_c16.nc','r')
temp_jas_c16 = f.variables['sst'][:]
salt_jas_c16 = f.variables['sss'][:]
f.close()

f = nc.Dataset('TS_jas_c4.nc','r')
temp_jas_c4 = f.variables['sst'][:]
salt_jas_c4 = f.variables['sss'][:]
f.close()

f = nc.Dataset('TS_jfm_c8.nc','r')
temp_jfm_c8 = f.variables['temp'][:]
salt_jfm_c8 = f.variables['salt'][:]
f.close()

f = nc.Dataset('TS_jfm_c16.nc','r')
temp_jfm_c16 = f.variables['temp'][:]
salt_jfm_c16 = f.variables['salt'][:]
f.close()

f = nc.Dataset('TS_jfm_c4.nc','r')
temp_jfm_c4 = f.variables['temp'][:]
salt_jfm_c4 = f.variables['salt'][:]
f.close()

f = nc.Dataset('TS_2000_c16.nc','r')
t2000_c16 = f.variables['temp'][:]
s2000_c16 = f.variables['salt'][:]
f.close()

f = nc.Dataset('TS_2000_c8.nc','r')
t2000_c8 = f.variables['temp'][:]
s2000_c8 = f.variables['salt'][:]
f.close()

f = nc.Dataset('TS_2000_c4.nc','r')
t2000_c4 = f.variables['temp'][:]
s2000_c4 = f.variables['salt'][:]
f.close()

ny, nx = temp_jas_c8.shape

f = nc.Dataset('grid.nc','r')
area = f.variables['area_t'][:]
f.close()

f = nc.Dataset('topog.nc','r')
depth = f.variables['depth'][:]
f.close()

temp_jas_c8.mask[depth < 200] = True
salt_jas_c8.mask[depth < 200] = True
temp_jas_c16.mask[depth < 200] = True
salt_jas_c16.mask[depth < 200] = True
temp_jas_c4.mask[depth < 200] = True
salt_jas_c4.mask[depth < 200] = True

temp_jfm_c8.mask[depth < 200] = True
salt_jfm_c8.mask[depth < 200] = True
temp_jfm_c16.mask[depth < 200] = True
salt_jfm_c16.mask[depth < 200] = True
temp_jfm_c4.mask[depth < 200] = True
salt_jfm_c4.mask[depth < 200] = True

jlim = 25
ir0 = 50
ir1 = 135
iw0 = 138
iw1 = 186


ip0 = 30
ip1 = 112
jp0 = 135
jp1 = 156

temp_jas_c16_ross = temp_jas_c16[:jlim, ir0:ir1]
temp_jas_c8_ross = temp_jas_c8[:jlim, ir0:ir1]
temp_jas_c4_ross = temp_jas_c4[:jlim, ir0:ir1]
# t2000_c16_ross = t2000_c16[:jlim, ir0:ir1]
# t2000_c8_ross = t2000_c8[:jlim, ir0:ir1]
# t2000_c4_ross = t2000_c4[:jlim, ir0:ir1]

temp_jas_c16_wedd = temp_jas_c16[:jlim, iw0:iw1]
temp_jas_c8_wedd = temp_jas_c8[:jlim, iw0:iw1]
temp_jas_c4_wedd = temp_jas_c4[:jlim, iw0:iw1]
# t2000_c16_wedd = t2000_c16[:jlim, iw0:iw1]
# t2000_c8_wedd = t2000_c8[:jlim, iw0:iw1]
# t2000_c4_wedd = t2000_c4[:jlim, iw0:iw1]

salt_jas_c16_ross = salt_jas_c16[:jlim, ir0:ir1]
salt_jas_c8_ross = salt_jas_c8[:jlim, ir0:ir1]
salt_jas_c4_ross = salt_jas_c4[:jlim, ir0:ir1]

salt_jas_c16_wedd = salt_jas_c16[:jlim, iw0:iw1]
salt_jas_c8_wedd = salt_jas_c8[:jlim, iw0:iw1]
salt_jas_c4_wedd = salt_jas_c4[:jlim, iw0:iw1]


temp_jfm_c16_pac = temp_jfm_c16[jp0:jp1, ip0:ip1]
salt_jfm_c16_pac = salt_jfm_c16[jp0:jp1, ip0:ip1]
temp_jfm_c8_pac = temp_jfm_c8[jp0:jp1, ip0:ip1]
salt_jfm_c8_pac = salt_jfm_c8[jp0:jp1, ip0:ip1]
temp_jfm_c4_pac = temp_jfm_c4[jp0:jp1, ip0:ip1]
salt_jfm_c4_pac = salt_jfm_c4[jp0:jp1, ip0:ip1]


temp_jas_c16_ross_av = np.ma.average(temp_jas_c16[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
salt_jas_c16_ross_av = np.ma.average(salt_jas_c16[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
temp_jas_c16_wedd_av = np.ma.average(temp_jas_c16[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])
salt_jas_c16_wedd_av = np.ma.average(salt_jas_c16[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])

t2000_c16_ross_av = np.ma.average(t2000_c16[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
s2000_c16_ross_av = np.ma.average(s2000_c16[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
t2000_c16_wedd_av = np.ma.average(t2000_c16[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])
s2000_c16_wedd_av = np.ma.average(s2000_c16[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])

temp_jas_c8_ross_av = np.ma.average(temp_jas_c8[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
salt_jas_c8_ross_av = np.ma.average(salt_jas_c8[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
temp_jas_c8_wedd_av = np.ma.average(temp_jas_c8[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])
salt_jas_c8_wedd_av = np.ma.average(salt_jas_c8[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])

t2000_c8_ross_av = np.ma.average(t2000_c8[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
s2000_c8_ross_av = np.ma.average(s2000_c8[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
t2000_c8_wedd_av = np.ma.average(t2000_c8[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])
s2000_c8_wedd_av = np.ma.average(s2000_c8[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])

temp_jas_c4_ross_av = np.ma.average(temp_jas_c4[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
salt_jas_c4_ross_av = np.ma.average(salt_jas_c4[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
temp_jas_c4_wedd_av = np.ma.average(temp_jas_c4[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])
salt_jas_c4_wedd_av = np.ma.average(salt_jas_c4[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])

t2000_c4_ross_av = np.ma.average(t2000_c4[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
s2000_c4_ross_av = np.ma.average(s2000_c4[:jlim, ir0:ir1], weights=area[:jlim, ir0:ir1])
t2000_c4_wedd_av = np.ma.average(t2000_c4[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])
s2000_c4_wedd_av = np.ma.average(s2000_c4[:jlim, iw0:iw1], weights=area[:jlim, iw0:iw1])

temp_jfm_c16_pac_av = np.ma.average(temp_jfm_c16[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])
temp_jfm_c8_pac_av = np.ma.average(temp_jfm_c8[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])
temp_jfm_c4_pac_av = np.ma.average(temp_jfm_c4[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])

t2000_c16_pac_av = np.ma.average(t2000_c16[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])
t2000_c8_pac_av = np.ma.average(t2000_c8[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])
t2000_c4_pac_av = np.ma.average(t2000_c4[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])

salt_jfm_c8_pac_av = np.ma.average(salt_jfm_c8[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])
salt_jfm_c16_pac_av = np.ma.average(salt_jfm_c16[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])
salt_jfm_c4_pac_av = np.ma.average(salt_jfm_c4[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])

s2000_c16_pac_av = np.ma.average(s2000_c16[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])
s2000_c8_pac_av = np.ma.average(s2000_c8[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])
s2000_c4_pac_av = np.ma.average(s2000_c4[jp0:jp1, ip0:ip1], weights=area[jp0:jp1, ip0:ip1])

s1 = np.arange(30.,35.8,0.1)
t1 = np.arange(0., 20.2, 0.1)
smat, tmat = np.meshgrid(s1, t1)
dens = m2003(smat, tmat, 0.)
dens = dens - 1000

light_blue = [0.5, 0.5, 1.0]
light_red = [1.0, 0.5, 0.5]
light_green = [0.4, 0.9, 0.4]

xlims = [32.3, 35.7]

levels = np.arange(20.6, 28.9, 0.4)

plt.figure(figsize=(6,12))

plt.subplot(311)

c = plt.contour(smat, tmat, dens, levels, colors='k', linewidths=0.5)

plt.scatter(salt_jas_c16_ross, temp_jas_c16_ross, s=2, color=light_blue)
plt.scatter(salt_jas_c16_wedd, temp_jas_c16_wedd, s=2, color=light_red)
plt.scatter(salt_jfm_c16_pac, temp_jfm_c16_pac, s=2, color=light_green)
h1 = plt.scatter(salt_jas_c16_ross_av, temp_jas_c16_ross_av, s=50, color='b')
h2 = plt.scatter(s2000_c16_ross_av, t2000_c16_ross_av, s=50, color='b', marker='s')
h3 = plt.scatter(salt_jas_c16_wedd_av, temp_jas_c16_wedd_av, s=50, color='r')
h4 = plt.scatter(s2000_c16_wedd_av, t2000_c16_wedd_av, s=50, color='r', marker='s')
h5 = plt.scatter(salt_jfm_c16_pac_av, temp_jfm_c16_pac_av, s=50, color='g')
h6 = plt.scatter(s2000_c16_pac_av, t2000_c16_pac_av, s=50, color='g', marker='s')

plt.legend((h1, h2, h3, h4, h5, h6), 
    ('Ross surf.', 'Ross 2000 m', 'Weddell surf.', 'Weddell 2000 m',
     'N. Pac. surf.', 'N. Pac. 2000 m'), loc='upper left')

plt.xlim(xlims)
plt.ylim([10,20])
plt.clabel(c, c.levels[::2], inline=True, fmt='%.1f', fontsize=8)

# plt.xlabel('Salinity')
plt.ylabel('Temperature (' + u'\xb0' + 'C)')
plt.title('(a) Sinking regions 1600 ppm')

plt.subplot(312)

c = plt.contour(smat, tmat, dens, levels, colors='k', linewidths=0.5)

plt.scatter(salt_jas_c8_ross, temp_jas_c8_ross, s=2, color=light_blue)
plt.scatter(salt_jas_c8_wedd, temp_jas_c8_wedd, s=2, color=light_red)
plt.scatter(salt_jfm_c8_pac, temp_jfm_c8_pac, s=2, color=light_green)
h1 = plt.scatter(salt_jas_c8_ross_av, temp_jas_c8_ross_av, s=50, color='b')
h2 = plt.scatter(s2000_c8_ross_av, t2000_c8_ross_av, s=50, color='b', marker='s')
h3 = plt.scatter(salt_jas_c8_wedd_av, temp_jas_c8_wedd_av, s=50, color='r')
h4 = plt.scatter(s2000_c8_wedd_av, t2000_c8_wedd_av, s=50, color='r', marker='s')
h5 = plt.scatter(salt_jfm_c8_pac_av, temp_jfm_c8_pac_av, s=50, color='g')
h6 = plt.scatter(s2000_c8_pac_av, t2000_c8_pac_av, s=50, color='g', marker='s')

plt.legend((h1, h2, h3, h4, h5, h6), 
    ('Ross surf.', 'Ross 2000 m', 'Weddell surf.', 'Weddell 2000 m',
     'N. Pac. surf.', 'N. Pac. 2000 m'), loc='upper left')

plt.xlim(xlims)
plt.ylim([6,16])
plt.clabel(c, c.levels[::2], inline=True, fmt='%.1f', fontsize=8)

# plt.xlabel('Salinity')
plt.ylabel('Temperature (' + u'\xb0' + 'C)')
plt.title('(b) Sinking regions 800 ppm')


plt.subplot(313)
c = plt.contour(smat, tmat, dens, levels, colors='k', linewidths=0.5)

plt.scatter(salt_jas_c4_ross, temp_jas_c4_ross, s=2, color=light_blue)
plt.scatter(salt_jas_c4_wedd, temp_jas_c4_wedd, s=2, color=light_red)
plt.scatter(salt_jfm_c4_pac, temp_jfm_c4_pac, s=2, color=light_green)
h1 = plt.scatter(salt_jas_c4_ross_av, temp_jas_c4_ross_av, s=50, color='b')
h2 = plt.scatter(s2000_c4_ross_av, t2000_c4_ross_av, s=50, color='b', marker='s')
h3 = plt.scatter(salt_jas_c4_wedd_av, temp_jas_c4_wedd_av, s=50, color='r')
h4 = plt.scatter(s2000_c4_wedd_av, t2000_c4_wedd_av, s=50, color='r', marker='s')
h5 = plt.scatter(salt_jfm_c4_pac_av, temp_jfm_c4_pac_av, s=50, color='g')
h6 = plt.scatter(s2000_c4_pac_av, t2000_c4_pac_av, s=50, color='g', marker='s')

plt.legend((h1, h2, h3, h4, h5, h6), 
    ('Ross surf.', 'Ross 2000 m', 'Weddell surf.', 'Weddell 2000 m',
     'N. Pac. surf.', 'N. Pac. 2000 m'), loc='upper left')

plt.xlim(xlims)
plt.ylim([0,15])
plt.clabel(c, c.levels[::2], inline=True, fmt='%.1f', fontsize=8)

plt.xlabel('Salinity (psu)')
plt.ylabel('Temperature (' + u'\xb0' + 'C)')
plt.title('(c) Sinking regions 400 ppm')


plt.savefig('watermass.pdf')